/* c't-Sim - Robotersimulator fuer den c't-Bot
 * 
 * This program is free software; you can redistribute it and/or modify it under the terms of the 
 * GNU General Public License as published by the Free Software Foundation; either version 2 of the 
 * License, or (at your option) any later version. This program is distributed in the hope that it 
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. You should 
 * have received a copy of the GNU General Public License along with this program; if not, write to 
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 * 
 * Dieser Code ist "quick and dirty" - also wohl fehlerhaft. Er kann schaedlich sein. Keine Haftung.
 * Author: Martin Henschke, Juli - Okt. 2006 
*/ 

#include "motor.h" 	// Variablen mit Sensor-Werten
#include "sensor.h" // Variablen fuer den Motor
#include "ct-Bot.h"
#include "bot-logik.h"
#include "display.h"
#include "bot-local.h"
#include "rc5.h"
#include "log.h"
//ll	#include <stdio.h> 
#include <stdlib.h>
#include <math.h>


int16 
	abkue = 0,		// Wenn 1, dann ist abkuerzen erlaubt
	abger = 440,	// min. Wandabstand bei Geradeausfahrt
	abkri = 960,	// kritischer Abstand fuer Abkuerzungen
	abtur = 120,	// kritischer Abstand fuer Turbo (max halbes Feld Fehler)
	aricht = 0,		// Ausrichtung zum Start, 0=unbekannt, 1=Blau nach rechts, 2=oben, 3=links
	blau,			// = 1 fuer blaue Startpos. und blau = -1 fuer rote Startpos.
	dis_l_m,		// Radencoder-Wert links merken
	dis_r_m,		// Radencoder-Wert rechts merken 
	enc_soll, 		// Radencoder-Wert, der erreicht werden soll
	enc_l_alt, 		// Radencoder-Wert links, vor einer Operation
	enc_r_alt, 		// Radencoder-Wert rechts, vor einer Operation
	fertig = 0, 	// 0, wenn fertig
	ferti2 = 0, 	// 0, wenn fertig
	ii, 			// Zaehler in Feldern
	job_z = 0,		// Job-Zaehler
	job_alt = 0,	// letzter Job
	job_a = 0, 		// zu erledigender Job
//ll	kk = 0,		// Ausgabenzaehler
	l_intens, 		// Lampen-Intensitaet merken
	l_winkel,		// Winkel zur naechsten Lampe
	l1_x,			// erste Lampe, x-Position
	l1_y,			// erste Lampe, x-Position
	lamp = -1,		// wenn = 0 dann ausgerichtet, wenn > 0 dann  Lampe (und Labyrinth-Ecke) gefunden
	sBL_alt, 		// sensBorderL merken
	sBR_alt, 		// sensBorderR merken
	sDR_alt, 		// sensDistR merken
	sensManL,		// manipulierter SensEncL-Wert
	stumpfw = 0,	// stumpfer Winkel zur Ecke
	turbo = 0,		// Turbo an Aussenwand
	w_kor = 0,		// Winkel-Korrektur
	winkel,			// Differenz der Radencoder-Werte
	w_test; 		// Wandtest: bei 2 steht der Bot an nur einer Wand
float
	alpha, 			// aktuelle Richtung
	ecke, 			// Entfernung zur Ecke
	ecka = 75.0, 	// max. Entfernung zur Ecke bei stumpfem Winkel
	fak, 			// Faktor zwischen den Abstandssensoren
	hx[41],			// historische x-Positionen 
	hy[41],			// historische y-Positionen 
    mot_x,      	// Motorgeschw. x
    mot_y,			// Motorgeschw. y
	Pi = 3.14159, 	// Pi
	rad_a = 48.5, 	// Radabstand vom Zentrum
	x_ecke,			// Koordinaten zur Ecke
	x_min,			// min. x_Wert aus Radencoder
	x_max,			// max. x_Wert aus Radencoder
	y_ecke,     	// Koordinaten zur Ecke
	y_min,			// min. y_Wert aus Radencoder
	y_max;			// max. y_Wert aus Radencoder
//ll	FILE
//ll	*maa;		// File log-Daten



/******************************************************************************************************/

float sig(float gg) { // Signum-Funktion
   if (gg < 0.0) return -1.0; else return 1.0;
}

void richt(void) { 	// Job Nr. 90 am Loch ausrichten
	if (fertig == 0) {
		fertig = 1; // nicht fertig
		ferti2 = 1;
		mot_x = 450.0;
		mot_y = 450.0;
		sBL_alt = sensBorderL;
		sBR_alt = sensBorderR;
	}
    if ((fertig > 0) && (sBL_alt != sensBorderL)) {
		fertig += 1; // nicht fertig
		sBL_alt = sensBorderL;
		mot_x /= 2.0;
    }
    if ((ferti2 > 0) && (sBR_alt != sensBorderR)) {
		ferti2 += 1; // nicht fertig
		sBR_alt = sensBorderR;
		mot_y /= 2.0;
    }
    if (sensBorderL > 900) mot_x = -fabs(mot_x); else mot_x = fabs(mot_x);
    if (sensBorderR > 900) mot_y = -fabs(mot_y); else mot_y = fabs(mot_y);
	motor_set(mot_x, mot_y); // je max. 450 in mm/s
    if ((fertig > 5) && (ferti2 > 5)) {
     	fertig = 0; 	// fertig
      	job_a = 0;  	// kein aktueller Job
		job_alt = 90; 
      	job_z++;     	// Zaehler hochzaehlen
	}
}	

void gerad(int16 enc_soll, int16 dist_soll) { 	// Jobs 1x zurueck oder nach vorne fahren
	if (fertig == 0) { // Job beginnt gerade
	    mot_x = sig(enc_soll) * 450.0;
    	mot_y = sig(enc_soll) * 450.0;
		motor_set(mot_x, mot_y); // je max. 450 in mm/s
		fertig = 1; // nicht fertig
		enc_l_alt = sensManL;
		enc_r_alt = sensEncR;
	} else {
	    if ((fertig == 1) && (((sensDistL + sensDistR) < dist_soll) 
	    || ((abs(sensManL - enc_l_alt) + abs(sensEncR - enc_r_alt) - abs(enc_soll)) >= 0))) {
	      	fertig = 0; 	// fertig
	      	job_a = 0;  	// kein aktueller Job
			if (dist_soll == abger) {
				job_alt = 10; 
				if ((fabs(x_max - x_min) < 20) && (fabs(y_max - y_min) < 20)) {
					job_alt = 12; // Wand direkt vorm Bot => wenig zurueck
				}
			}
			if (enc_soll  == -82) job_alt = 11; 
			if (enc_soll  == -40) job_alt = 14; 
			if (enc_soll  == -15) job_alt = 13; 
			if (dist_soll ==   2) {
				job_alt = 18; 
				x_ecke = x_ecke * ecka / ecke;
				y_ecke = y_ecke * ecka / ecke;
				ecke = ecka; // neue Entfernung zur Ecke
			}
			if (dist_soll ==   1) job_alt = 19; 
	      	job_z++;     	// Zaehler hochzaehlen
	    }
	}
}	

void drehe90(void) { 	// Job Nr. 91 Linksdrehung um 90 fuer Blau, Rechtsdrehung fuer Rot
	if (fertig == 0) { // Job beginnt gerade
	    mot_x = -blau * 450.0;
    	mot_y = +blau * 450.0;
		motor_set(mot_x, mot_y); // je max. 450 in mm/s
		enc_soll = 51; 
		fertig = 1; // nicht fertig
		enc_l_alt = sensManL;
		enc_r_alt = sensEncR;
	} else {
	    if ((fertig == 1) && ((abs(sensManL - enc_l_alt) + abs(sensEncR - enc_r_alt) 
	    - enc_soll) > -20)) { // bis 0 langsamer
			motor_set(0.2 * mot_x, 0.2 * mot_y);
			fertig = 2;
	    }
	    if ((fertig == 2) && ((abs(sensManL - enc_l_alt) + abs(sensEncR - enc_r_alt) 
	    - enc_soll) >= 0)) {
	      	fertig = 0; 	// fertig
	      	job_a = 0;  	// kein aktueller Job
			job_alt = 91; 
	      	job_z++;     	// Zaehler hochzaehlen
	    }
	}
}	

void parallel(void) { // Job Nr. 92 parallel zur Wand ausrichten
	if (fertig == 0) { // Job beginnt gerade
	    mot_x = -blau * 450.0;
    	mot_y = +blau * 450.0;
		motor_set(mot_x, mot_y); // je max. 450 in mm/s
      	enc_soll = 204.21 * alpha / (2.0 * Pi);
		fertig = 1; // nicht fertig
		enc_l_alt = sensManL;
		enc_r_alt = sensEncR;
	} 
    if ((fertig == 1) && ((abs(sensManL - enc_l_alt) + abs(sensEncR - enc_r_alt) 
    - enc_soll) > -10)) { // bis 0 langsamer
		motor_set(0.2 * mot_x, 0.2 * mot_y);
		fertig = 2;
    }
    if ((fertig == 2) && ((abs(sensManL - enc_l_alt) + abs(sensEncR - enc_r_alt) 
    - enc_soll) >= 0)) {
      	fertig = 0; 	// fertig
      	job_a = 0;  	// kein aktueller Job
		job_alt = 92; 
      	job_z++;     	// Zaehler hochzaehlen
    }
}	

void drehe_0(int16 enc_soll) { 	// Job Nr. 30 Linksdrehung auf 0fuer Blau, Nr. 32 - 90
	if (fertig == 0) { // Job beginnt gerade
		if (blau * (sensEncR - sensManL) < (enc_soll - 5)) {
		    mot_x = (1 - blau) * 225.0;
    		mot_y = (1 + blau) * 225.0;
			fertig = 1;
		} else {
		    mot_x = (1 - blau) * 22.5;
    		mot_y = (1 + blau) * 22.5;
    		fertig = 2;
		}			
		motor_set(mot_x, mot_y); // je max. 450 in mm/s
	} else { // mindestens ein Durchlauf
		if ((fertig == 1) && (blau * (sensEncR - sensManL) > (enc_soll - 5))) { // langsamer werden
			motor_set(0.1 * mot_x, 0.1 * mot_y); // je max. 450 in mm/s
			fertig = 2;
		}
	    if ((fertig == 2) && (blau * (sensEncR - sensManL) >= enc_soll)) { 
	    	fertig = 0; 	// fertig
	      	job_a = 0;  	// kein aktueller Job
			if (enc_soll ==  0) job_alt = 30; 
			if (enc_soll == 51) job_alt = 32; 
	      	job_z++;     	// Zaehler hochzaehlen
	    }
	} 
}	

void wandtest(void) { 	// Job Nr. 93, 94 Rechtsdrehung um die Anzahl der Waende und die Richtung zu pruefen
	if (fertig == 0) { // Job beginnt gerade
	    mot_x =  blau * 450.0;
    	mot_y = -blau * 450.0;
		motor_set(mot_x, mot_y); // je max. 450 in mm/s
		sDR_alt = sensDistR; 
		w_test = 0;
		l_winkel = 0; 	 // Winkel zur Lampe, wenn denn eine da ist
		l_intens = 2046; // maximal festgestellte Lampenintensitaet
		fertig = 1;
	} else { 
		if ((fertig == 1) && ((sensLDRL + sensLDRR) < l_intens)) {
			l_intens = sensLDRL + sensLDRR;
			l_winkel = blau * (sensEncL - sensEncR);
		}
		if ((fertig == 1) && (sensDistR < 100) && (sDR_alt >= 100)) {
			w_test++;
			winkel = blau * (sensEncL - sensEncR);
		}
		sDR_alt = sensDistR; 
	    if ((fertig == 1) && (blau * (sensEncL - sensEncR) >= 204)) { 
			if (w_test == 2) { // nur eine Wand, Ausrichtung eindeutig
				aricht = 1;
				w_kor = 204; // stehen bleiben
				if ((winkel > 100) && (winkel < 150)) { 
					aricht = 2;
					w_kor = 51; // 270 zurueckdrehen
				}
				if (winkel > 150) {
					aricht = 3;
					w_kor = 102; // 180 zurueckdrehen
				}
			} else { // Ausrichtung durch Wand-Test nicht eindeutig
				w_kor = 204; // stehen bleiben
				if (l_intens < 2046) { // Ausrichtung durch Lampentest eindeutig
					aricht = 1;
					if ((l_winkel > 50) && (l_winkel < 100)) { 
						aricht = 2;
						w_kor = 51; // 270 zurueckdrehen
					}
					if (l_winkel > 100) {
						aricht = 3;
						w_kor = 102; // 180 zurueckdrehen
					}
				}
			}
	    	fertig = 2; 	// fertig
			motor_set(-mot_x, -mot_y); // schnell zurueck
	    }
	    if ((fertig == 2) && (blau * (sensEncL - sensEncR) < (w_kor + 10))) { // zurueckdrehen
	    	fertig = 3;
			motor_set(-0.1 * mot_x, -0.1 * mot_y); // langsam ins Ziel
	    }
	    if ((fertig == 3) && (blau * (sensEncL - sensEncR) <= w_kor)) { // zurueckgedreht
	      	job_a = 0;  	// kein aktueller Job
	      	fertig = 0;
			job_alt = 93; // Bot muss die Lampe rechts unten finden.
			if (aricht > 0) job_alt = 94; // Bot steht in richtiger Startposition
	      	job_z++;    	// Zaehler hochzaehlen
	    }
	}
}	

void bogen(float rr, int16 enc_soll, int16 dist_soll) {	// Jobs 3x und 4x, rr < 0 linksrum
	if (fertig == 0) { // Job beginnt gerade
		fak = fabs(rr / rad_a);
	    mot_x = sig(enc_soll) * (fak + sig(rr) * blau) * 450.0 / (fak + 1);
    	mot_y = sig(enc_soll) * (fak - sig(rr) * blau) * 450.0 / (fak + 1);
		motor_set(mot_x, mot_y); // je max. 450 in mm/s
		fertig = 1; // nicht fertig
		enc_l_alt = sensManL;
		enc_r_alt = sensEncR;
		dis_l_m = sensDistL; 	// fuer Ecken-Finder merken
		dis_r_m = sensDistR;
		stumpfw = 0;			// kein stumpfer Winkel zur Ecke
		if (aricht == 0) { 		// Ausrichtung noch unklar, Lampe finden
			l_winkel = 0; 		// Winkel zur Lampe, wenn denn eine da ist
			l_intens = 1500; 	// maximal festgestellte Lampenintensitaet
		}
	} else {
		if ((aricht == 0) && ((sensLDRL + sensLDRR) < l_intens)) {
			fak = ((float) sensLDRL) / ((float) sensLDRR);
			if (fak > 1.0) fak = 1.0 / fak;
			if (fak > 0.982) { // beide Sensoren gleich hell -> Blick zur Lampe 
				l_intens = sensLDRL + sensLDRR;
				l_winkel = blau * (sensManL - sensEncR);
			}
		}
		ecke = 0.0; // keine Ecke gefunden
		if (blau == 1) { // blauer Bot
			if (((sensDistR < 360) && (rr > 0.1)) || ((dis_r_m < 260) && (rr < -0.1))) { // rechts bzw. links
				fak = ((float) sensDistR) / ((float) dis_r_m);
				if (fak > 1.0) fak = 1.0 / fak;
				if (fak < 0.6) {
			      	alpha = 2.0 * Pi * (sensManL - sensEncR) / 204.21;
			      	while (alpha > (0.5 * Pi)) alpha -= 0.5 * Pi; // Winkel muss 0-90 sein
			      	while (alpha <        0.0) alpha += 0.5 * Pi; // Winkel muss 0-90 sein
		      		if (dis_r_m > sensDistR) ecke = sensDistR; else ecke = dis_r_m; // Abstand zur Ecke
			      	if (alpha < 0.77) stumpfw = 0; else stumpfw = 1; // Ecke im spitzen bzw. stumpfen Winkel
				}
			}
	 	}
		if (blau == -1) { // roter Bot
			if (((sensDistL < 360) && (rr > 0.1)) || ((dis_l_m < 260) && (rr < -0.1))) { // rechts bzw. links
				fak = ((float) sensDistL) / ((float) dis_l_m);
				if (fak > 1.0) fak = 1.0 / fak;
				if (fak < 0.6) {
			      	alpha = 2.0 * Pi * (sensEncR - sensManL) / 204.21;
			      	while (alpha > (0.5 * Pi)) alpha -= 0.5 * Pi; // Winkel muss 0-90 sein
			      	while (alpha <        0.0) alpha += 0.5 * Pi; // Winkel muss 0-90 sein
		      		if (dis_l_m > sensDistL) ecke = sensDistL; else ecke = dis_l_m; // Abstand zur Ecke
			      	if (alpha < 0.77) stumpfw = 0; else stumpfw = 1; // Ecke im spitzen bzw. stumpfen Winkel
				}
			}
		}
		dis_r_m = sensDistR;
		dis_l_m = sensDistL; 

	    if ((fertig == 1) && (((abs(sensManL - enc_l_alt) + abs(sensEncR - enc_r_alt) - enc_soll) > 0)
	    || ((rr > 0.1) && (abkue == 1) && ((blau * (sensEncR - sensManL)) <= 0) 
	    && ((blau * (sensEncR - sensManL)) >= -10)) // zurueck ist bloed
    	|| ((rr > 0.1) && (sensDistL < 200)) || ((rr > 0.1) && (sensDistR < 200))
    	|| ((fabs(rr) > 0.1) && (ecke >= 0.01)))) { 
	      	fertig = 0; 	// fertig
	      	job_a = 0;  	// kein aktueller Job
			if (fabs(290.0 - rr) < 0.01) job_alt = 41; // grosser Rechts-Bogen um ein Loch
			if (fabs(169.7 - rr) < 0.01) job_alt = 40; // Rechtsdrehung bis Wandabstand erreicht
			if (fabs( 48.5 - rr) < 0.01) job_alt = 43; // enge Rechtsdrehung bis Wandabstand
			if (fabs(-25.0 - rr) < 0.01) job_alt = 31; // Linksdrehung normal oder wenig
			if ((abkue == 1) && ((blau * (sensEncR - sensManL)) <= 0) 
			&& ((blau * (sensEncR - sensManL)) >= -10)) { // nicht zurueck
				job_alt = 42; 
			}
	      	if ((aricht == 0) && (l_intens < 1500)) { // Lampe gefunden, Ausrichtung klar
	      		aricht = 1;
				w_kor += 0;
				if (l_winkel > 50) {
					aricht = 2;
					w_kor += 51;  //  90
				}
				if (l_winkel > 100) {
					aricht = 3;
					w_kor += 51; // 180
				}
	      	}
	      	if (ecke >= 0.01) {    	
	      		ecke = 2.0 * ecke / 2.9845; // Entfernung in Encoder-Einheiten
		      	y_ecke = fabs(ecke * sin(alpha));
		      	x_ecke = fabs(ecke * cos(alpha));
		      	job_alt = 44; // spitzer Winkel zur Ecke
		      	if ((stumpfw == 1) && (ecke > ecka)) job_alt = 45; // stumpfer Winkel zur Ecke
	      	}
			if ((turbo == 1) && (job_alt == 40)  // extraschnell an der Auenwand lang
			&& (((blau == -1) && (sensDistL > 185) && (sensDistL < 202) && (sensDistR > 310) && (sensDistR < 330))
			|| ((blau == 1) && (sensDistR > 185) && (sensDistR < 202) && (sensDistL > 310) && (sensDistL < 330)))) {
				job_alt = 46; 
			}
	      	job_z++;     	// Zaehler hochzaehlen
	    }
	}
}	

void abkuerz(void) {
	if (x_enc < x_min) x_min = x_enc; // Min. und Max. Koordinaten merken -> wenn der 
	if (x_enc > x_max) x_max = x_enc; // Bot nicht weiter als knapp 5 Felder von einer
	if (y_enc < y_min) y_min = y_enc; // Wand weg ist, darf er abkuerzen
	if (y_enc > y_max) y_max = y_enc;
	if ((lamp == -1) && (aricht > 0) && (job_z > 0)) { // Bot ist auf der Grundlinie und kennt seine Richtung
		lamp = 0; // noch keine Lampe gefunden, aber nach unten darf abgekuerzt werden
		w_kor += 51;
	}
	if ((lamp == 0) && ((sensLDRL < 600) || (sensLDRR < 600))) { // erste Lampe gefunden
		l1_x = x_enc;
		l1_y = y_enc;
		lamp = 1; // Labyrinth-Begrenzung (1te Lampe) gefunden
		w_kor -= 51; // Winkel eingrenzen
	}
	if ((lamp == 1) && ((sensLDRL < 600) || (sensLDRR < 600))) { // ggf zweite Lampe gefunden
		if ((fabs(l1_x - x_enc) > 1000.0) || (fabs(l1_y - y_enc) > 1000.0)) {
			lamp = 2; // 2te Lampe
			w_kor -= 51; // Winkel eingrenzen
		}
	}
	abkue = 0; // jedesmal neu pruefen!
	turbo = 0;

	if (((lamp == 1) && (aricht == 1)) || ((lamp == 2) && (aricht == 2))) { 
		if ((x_max - x_enc) < abkri) abkue = 1; // Bot darf in positiver x-Richtung abkuerzen
		if ((lamp != 2) && ((x_max - x_enc) < abtur)) turbo = 1;
	}
	if (((lamp == 0) && (aricht == 2)) || ((lamp == 1) && (aricht == 3))) { 
		if ((x_enc - x_min) < abkri) abkue = 1; // Bot darf in negativer x-Richtung abkuerzen
		if ((x_enc - x_min) < abtur) turbo = 1;
	}
	if (blau == 1) { // nur blauer Bot
		if (((lamp == 0) && (aricht == 3)) || ((lamp == 2) && (aricht == 1))) { 
			if ((y_max - y_enc) < abkri) abkue = 1; // Bot darf in positiver y-Richtung abkuerzen
			if ((lamp != 2) && ((y_max - y_enc) < abtur)) turbo = 1;
		}
		if (((lamp == 0) && (aricht == 1)) || ((lamp == 1) && (aricht == 2)) || ((lamp == 2) && (aricht == 3))) { 
			if ((y_enc - y_min) < abkri) abkue = 1; // Bot darf in negativer y-Richtung abkuerzen
			if ((lamp != 2) && ((y_enc - y_min) < abtur)) turbo = 1;
		}
	}
	if (blau == -1) { // nur roter Bot
		if (((lamp == 0) && (aricht == 3)) || ((lamp == 2) && (aricht == 1))) { 
			if ((y_enc - y_min) < abkri) abkue = 1; // Bot darf in negativer y-Richtung abkuerzen
			if ((lamp != 2) && ((y_enc - y_min) < abtur)) turbo = 1;
		}
		if (((lamp == 0) && (aricht == 1)) || ((lamp == 1) && (aricht == 2)) || ((lamp == 2) && (aricht == 3))) { 
			if ((y_max - y_enc) < abkri) abkue = 1; // Bot darf in positiver y-Richtung abkuerzen
			if ((lamp != 2) && ((y_max - y_enc) < abtur)) turbo = 1;
		}
	}
}

/************************************ Die Winner-Funktion ******************************************/
void bot_behave(void){	
	
	sensManL = sensEncL - blau * w_kor;	// in den manipulierten Wert wird die Ausrichtung eingerechnet

	/*****  Startbedingungen festlegen, nur einmal am Anfang: *****/
    if ((job_z == 0) && (job_a == 0)) {
   		if ((sensBorderL + sensBorderR) > 1508) {
   			blau = 1; 	// Blauer Bot
   		} else {
   			blau = -1; // Roter Bot
   		}
		if (blau * (sensLDRL - sensLDRR) > 0) aricht = 1; // Blau sieht nach rechts, Rot nach links
		sensManL = 0; // sicher ist sicher
		sensEncR = 0;
		if (aricht == 1) { // aricht = Ausrichtung
			job_a = 10; // erstmal geradeaus
		} else { 
			job_a = 93; // Waende in der Umgebung checken, rechtsrum um die eigene Achse
		}
		for (ii = 0; ii <= 40; ii++) { // Festfahr-Ueberpruefung: Start-Probleme vermeiden
			hx[ii] = 9999.9;
			hy[ii] = 9999.9;
		}
//ll	if (blau == 1) {maa = fopen("blau.maa", "w"); fclose(maa);}
//ll	if (blau == -1) {maa = fopen("rot.maa", "w"); fclose(maa);}
    }

	/***** pruefen, ob der Bot sich festgefahren hat: *****/
	if (job_a < 90) { // auf der Stelle drehen oder (fast) stehen darf nicht gewertet werden
		// Es muessen mindestens 6 Positionen gespeichert werden, bis die Mausdaten aktualisiert werden
		for (ii = 40; ii > 0; ii--) { // Positionen hochschieben
			hx[ii] = hx[ii-1];
			hy[ii] = hy[ii-1];
		}
		hx[0] = x_mou;
		hy[0] = y_mou;
	}
	if ((fabs(x_mou - hx[40]) < 0.0001) && (fabs(y_mou - hy[40]) < 0.0001)) { // Bot haengt fest
		job_a = 13; 	// zurueck
		fertig = 0;		// alles bisherige vergessen
	}
	
    /***** pruefen, ob der Bot in ein Loch faellt: *****/
	if (((job_a != 0) && (job_a != 90) && (job_alt != 90)) && ((sensBorderL > 900) || (sensBorderR > 900))) {	// Loch
		job_a = 90; 	// am Loch ausrichten
		fertig = 0;		// alles bisherige vergessen
	}

    /***** pruefen, ob Abkuerzungen moeglich und erlaubt: *****/
	abkuerz(); 

//ll	/***** Ggf. Daten in Log-Datei schreiben: *****/
//ll	kk++;
//ll	if (kk == 3) {
//ll		kk = 0;
//ll		if (blau == 1) { 
//ll			maa = fopen("blau.maa", "a"); 
//ll			fprintf(maa, "%9.2f %9.2f\n", x_enc, y_enc); 
//ll		    fclose(maa); 
//ll		} else { 
//ll			maa = fopen("rot.maa", "a"); 
//ll			fprintf(maa, "%9.2f %9.2f\n", x_enc, y_enc); 
//ll		    fclose(maa); 
//ll		} 
//ll	}

	/******** KI nach dem Start, rechts und links bezieht sich immer auf den blauen Bot: ********/
	if (job_a == 0) { // neuen Job finden, alte Jobs in job_alt
		switch(abs(job_alt)) { // neuer Job in Abhaengigkeit des alten
			case 10: job_a = 33; break;  // vorher geradeaus, jetzt wenig linksrum
			case 11: job_a = 91; break;  // vorher am Loch zurueck, jetzt 90 linksrum
			case 12: job_a = 14; break;  // vorher gerade vor Wand, jetzt etwas zurueck
			case 13: job_a = 31; break;  // vorher kurz zurueck, jetzt linksrum
			case 14: job_a = 31; break;  // vorher etwas zurueck, jetzt linksrum
			case 18: job_a = 92; break;  // vorher naeher zur Ecke, jetzt parallel ausrichten
			case 19: job_a = 40; break;  // vorher bis Ecke, jetzt rechtsrum 
			case 30: job_a = 10; break;  // vorher auf 0 gedreht, jetzt geradeaus
			case 31: job_a = 40; break;  // vorher linksrum, jetzt rechtsrum
			case 32: job_a = 10; break;  // vorher auf 90 gedreht, jetzt geradeaus
			case 40: job_a = 31; break;  // vorher rechtsrum, jetzt linksrum
			case 41: job_a = 31; break;  // vorher grosser Bogen, jetzt linksrum
			case 42: job_a = 30; break;  // vorher rechtsrum (nicht zurueck), jetzt auf 0 drehen
			case 43: job_a = 31; break;  // vorher eng rechtsrum, jetzt linksrum
			case 44: job_a = 92; break;  // vorher Ecke gefunden, jetzt parallel ausrichten
			case 45: job_a = 15; break;  // vorher stumpfe Ecke gefunden, jetzt naeher ran
			case 46: job_a = 32; break;  // vorher rechtsrum (turbo), jetzt auf 90 drehen
			case 90: job_a = 11; break;  // vorher ausgerichtet, jetzt am Loch zurueck
			case 91: job_a = 41; break;  // vorher 90 links, jetzt grossen Bogen
			case 92: job_a = 19; break;  // vorher parallel ausrichten, jetzt bis Ecke
			case 93: job_a = 43; break;  // vorher Wand gesucht und nicht gefunden, jetzt eng rechtsrum
			case 94: job_a = 10; break;  // vorher Wand gesucht und gefunden, jetzt geradeaus
		} 
	}

	// Jobs 1x: gerad(Strecke -oo bis oo , Wandabstand) 
	// Jobs 3x (linksrum) und 4x (rechts): bogen(Radius -oo bis oo , Weite -oo bis oo, Wandabstand)
	// Jobs 9x (keine Festfahr-Ueberpruefung)
	switch(abs(job_a)) { // zum aktuellen Job springen
		case 10: gerad(1440, abger);		break;  // geradeaus fahren, max 6 Felder
		case 11: gerad(-82, 0);				break;  // am Loch zurueck
		case 13: gerad(-15, 0);				break;  // ein Stueck zurueck
		case 14: gerad(-40, 0);				break;  // etwas zurueck
		case 15: gerad(ecke - ecka, 2);		break;  // naeher an Ecke ran
		case 19: gerad(x_ecke, 1);			break;  // bis Ecke vor
		case 30: drehe_0(0);				break;  // auf 0 drehen
		case 31: bogen(-25.0,  33, 9999);	break;  // Linksdrehung normal
		case 32: drehe_0(51);				break;  // auf 90 drehen
		case 33: bogen(-25.0,  16, 9999);	break;  // Linksdrehung wenig
		case 40: bogen(169.7, 9999, abger);	break;  // Rechtsdrehung bis Wandabstand erreicht
		case 41: bogen(290.0, 9999, abger);	break;  // grosser Rechtsbogen
		case 43: bogen( 48.5, 9999, abger);	break;  // enger Rechtsbogen
		case 90: richt();					break;  // am Loch ausrichten
		case 91: drehe90();					break;  // Linksdrehung 90 fuer Blau
		case 92: parallel();				break;  // parallel ausrichten 
		case 93: wandtest();				break;  // Rechtsdrehung max 360 
	}
}

// Erforderlich, aber ueberfluessig:
volatile int16 target_speed_l=BOT_SPEED_STOP;
volatile int16 target_speed_r=BOT_SPEED_STOP;
float target_x;
float target_y;
void activateBehaviour(BehaviourFunc function){}
void deactivateBehaviour(BehaviourFunc function){}
void deactivateAllBehaviours(void){}
void bot_drive_square_behaviour(Behaviour_t *data){}
void bot_goto_behaviour(Behaviour_t *data){}
void bot_drive_distance_behaviour(Behaviour_t* data){}
void bot_drive_distance(Behaviour_t* caller,int8 curve, int16 speed, int16 cm){}
void bot_turn_behaviour(Behaviour_t* data){}
void bot_turn(Behaviour_t* caller,int16 degrees){}
void bot_explore_behaviour(Behaviour_t *data){}
void bot_do_slalom_behaviour(Behaviour_t *data){}
void bot_olympic_behaviour(Behaviour_t *data){}
void bot_check_wall_behaviour(Behaviour_t *data) {}
void bot_solve_maze(Behaviour_t *caller){}
void bot_behave_init(void){}
